// Obj.cpp : implementation file
//

#include "stdafx.h"
#include "BSOFT.h"
#include "Obj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObj

IMPLEMENT_DYNCREATE(CObj, CCmdTarget)

CObj::CObj(CORBA::ORB_ptr orb):orb(orb)
{
	EnableAutomation();
}

CObj::CObj()
{
	EnableAutomation();
}


CObj::~CObj()
{
	
}


void CObj::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.
	
	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CObj, CCmdTarget)
//{{AFX_MSG_MAP(CObj)
// NOTE - the ClassWizard will add and remove mapping macros here.
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CObj, CCmdTarget)
//{{AFX_DISPATCH_MAP(CObj)
DISP_FUNCTION(CObj, "Invoke", Invoke, VT_VARIANT, VTS_BSTR VTS_PVARIANT VTS_I2 VTS_I2)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IObj to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {83CA87C5-FA92-11D1-87FA-0007210603AA}
static const IID IID_IObj =
{ 0x83ca87c5, 0xfa92, 0x11d1, { 0x87, 0xfa, 0x0, 0x7, 0x21, 0x6, 0x3, 0xaa } };

BEGIN_INTERFACE_MAP(CObj, CCmdTarget)
INTERFACE_PART(CObj, IID_IObj, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObj message handlers

VARIANT CObj::Invoke(LPCTSTR MethodName, VARIANT FAR* Parameters, short NumOfParameters, short ReturnType) 
{
	VARIANT vaResult;
	VariantInit(&vaResult);
	CORBA::OperationDef_var oper_def ;
	try 
	{
		
		if (intf == CORBA::InterfaceDef::_nil()) 
		{
			AfxMessageBox("Account returned a nil interface definition. " );
			AfxMessageBox("  Be sure an Interface Repository is running and" );
			AfxMessageBox("  properly loaded" );
			exit(3);
		}
		CORBA::Contained_var oper_container = intf->lookup(MethodName);
		oper_def = CORBA::OperationDef::_narrow(oper_container);
		orb->create_operation_list(oper_def, operation_list.out());
		req = obj->_request(MethodName);
		//result = req->result();
		orb->create_named_value(result.out());
		resultAny = result->value();
		resultAny->replace(oper_def->result(), &result);
		req->set_return_type(oper_def->result());

		
	} 
	catch(const CORBA::Exception& excep) 
	{
		AfxMessageBox("Error while obtaining operation list" );
		exit(4);
	}
	// Create request that will be sent to the account object
	try 
	{
		
		for(int numParams = 0;numParams < NumOfParameters;numParams++)
		{
			if(Parameters[numParams].vt == VT_BSTR)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				if((arg->flags() == CORBA::ARG_IN) )
				{
					CORBA::Any_ptr anyArg = arg->value();
					CString csVal = Parameters[numParams].bstrVal;
					char *a = new char[csVal.GetLength()];
					strcpy(a,csVal);
					*anyArg <<= (char *)a;
				}
				else if((arg->flags() == CORBA::ARG_INOUT))
				{
					CORBA::Any_ptr anyArg = arg->value();
					*anyArg <<= (char *) Parameters[numParams].bstrVal;
				}
				else if((arg->flags() == CORBA::ARG_OUT))
				{
					CORBA::String_var a;
					CORBA::Any_ptr anyArg = arg->value();
					*anyArg <<= (char *)a;
				}
				
			}
			else if(Parameters[numParams].vt == VT_I2)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				CORBA::Any_ptr anyArg = arg->value();
				*anyArg <<= (CORBA::Short)Parameters[numParams].iVal;
			}
			else if(Parameters[numParams].vt == VT_I4)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				CORBA::Any_ptr anyArg = arg->value();
				*anyArg <<= (CORBA::Long)Parameters[numParams].lVal;
			}
			else if(Parameters[numParams].vt == VT_R4)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				CORBA::Any_ptr anyArg = arg->value();
				*anyArg <<= (CORBA::Float) Parameters[numParams].fltVal;
			}
			else if(Parameters[numParams].vt == VT_R8)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				CORBA::Any_ptr anyArg = arg->value();
				*anyArg <<= (CORBA::Double) Parameters[numParams].dblVal;
			}
			else if(Parameters[numParams].vt == VT_BOOL)
			{
				
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				CORBA::Any_ptr anyArg = arg->value();
				if(Parameters[numParams].boolVal == VARIANT_TRUE)
				{
					bool *tempBool = new bool;
					*tempBool = true;
					anyArg->replace(CORBA::_tc_boolean,tempBool);
				}
				else
				{
					bool *tempBool = new bool;
					*tempBool = false;
					anyArg->replace(CORBA::_tc_boolean,tempBool);
				}
				
			}
			else if(Parameters[numParams].vt == VT_DISPATCH)
			{
				CORBA::NamedValue_ptr arg = operation_list->item(numParams);
				if(arg->flags() == CORBA::ARG_OUT)
				{
					CORBA::Any_ptr obj;
					CORBA::Any_ptr anyArg = arg->value();
					*anyArg <<= (CORBA::Object*)obj;
					
				}
				else if((arg->flags() == CORBA::ARG_IN)||(arg->flags() == CORBA::ARG_INOUT))
				{
					CObj *pOBJ = (CObj*)CCmdTarget::FromIDispatch(Parameters[numParams].pdispVal);
					CORBA::Any_ptr anyArg = arg->value();
					*anyArg <<= (CORBA::Object*)pOBJ->obj;
				}
				
			}
			
		}			

        //Setting the Exceptions that could be raised by the operation Specified 
		/*CORBA::ExceptionDefSeq_var excep_var = oper_def->exceptions();
		CORBA::ExceptionList_ptr exceptionList = req->exceptions();
		for(int i = 0; i< excep_var->length(); i++)
		{
			cout << (*excep_var)[i]->type()->name() << endl;
			exceptionList->add_consume((*excep_var)[i]->type());
		}
		CORBA::ContextList_ptr context_List = req->contexts();
		*/obj->_create_request(CORBA::Context::_nil(),
			MethodName,
			operation_list,
			result,
			//exceptionList,
			//context_List ,//req->contexts(),
			req.out(),
			0);
		
	}
	catch(const CORBA::Exception& excep) 
	{
		AfxMessageBox("Error while creating request" );
		exit(5);
	}
	
	// Execute the request
	try 
	{
		req->invoke();
		CORBA::Environment_ptr env = req->env();
		CORBA::Exception *except    = env->exception();
		if ( except ) 
		{
			CORBA::UnknownUserException *unknown =
				CORBA::UnknownUserException::_narrow(except);
			if (unknown) 
			{
				CORBA::Any &anyExcept = unknown->exception();
				if(anyExcept.type()->member_type(0)->kind()==CORBA::TCKind::tk_string)
				{
					char*s1 = CORBA::string_alloc(10);
					anyExcept>>=s1;
					char*a ="Sriram";
					CORBA::Any any;
					any<<=(const char*)a;
					cout << a;
					char*s = new char[50];
					any	>>=(char*)s;
					cout << s;
				
				}
				else if(anyExcept.type()->member_type(0)->kind()==CORBA::TCKind::tk_long)
				{
					CORBA::Long l;
					l = *(CORBA::Long *)anyExcept.value();;
					cout << "Not Unknown" << endl;
				}
				else if(anyExcept.type()->member_type(0)->kind()==CORBA::TCKind::tk_short)
				{
					CORBA::Short l;
					l = *(CORBA::Short*)anyExcept.value();;
					cout << "Not Unknown" << endl;
				}

			}
			else 
			{
				cout << "Unexpected user exception" << endl;
				cout << except << endl;
			}
		}
		else  
		{
			//Fill the Array of Parameters with the values again
			CORBA::NVList_ptr retArgs = req->arguments();
			for(int numParams = 0;numParams < NumOfParameters;numParams++)
			{
				if(Parameters[numParams].vt == VT_BSTR)
				{
					CORBA::NamedValue_ptr arg = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						CORBA::Any_ptr anyArg = arg->value();
						char*Val;
						*anyArg >>= (char *)Val;
						CString csVal(Val);
						VariantInit(&Parameters[numParams]);
						Parameters[numParams].vt = VT_BSTR;
						Parameters[numParams].bstrVal = csVal.AllocSysString();
					}
				}
				else if(Parameters[numParams].vt == VT_I2)
				{	
					CORBA::NamedValue_ptr arg = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg >>= (CORBA::Short)Parameters[numParams].iVal;
					}
				}
				else if(Parameters[numParams].vt == VT_I4)
				{
					CORBA::NamedValue_ptr arg  = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg >>= (CORBA::Long)Parameters[numParams].lVal;
					}
				}
				else if(Parameters[numParams].vt == VT_R4)
				{
					CORBA::NamedValue_ptr arg  = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg <<= (CORBA::Float) Parameters[numParams].fltVal;
					}
				}
				else if(Parameters[numParams].vt == VT_R8)
				{
					CORBA::NamedValue_ptr arg = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg >>= (CORBA::Double) Parameters[numParams].dblVal;
					}
				}
				else if(Parameters[numParams].vt == VT_BOOL)
				{
					
					CORBA::NamedValue_ptr arg = retArgs->item(numParams);
					if((arg->flags() == CORBA::ARG_OUT) || (arg->flags() == CORBA::ARG_INOUT))
					{
						Parameters[numParams].boolVal =*(CORBA::Boolean*)resultAny->value();
					}
				}
				else if(Parameters[numParams].vt == VT_DISPATCH)
				{
					CORBA::NamedValue_ptr arg = retArgs->item(numParams);
					if(arg->flags() == CORBA::ARG_INOUT)
					{
						CObj *pOBJ = (CObj*)CCmdTarget::FromIDispatch(Parameters[numParams].pdispVal);
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg >>= (CORBA::Object*)pOBJ->obj ;
					}
					else if(arg->flags() == CORBA::ARG_OUT)
					{
						CORBA::Object_ptr objGot;
						CORBA::Any_ptr anyArg = arg->value();
						*anyArg >>= (CORBA::Object*)objGot;
						CObj *objtemp= new CObj;
						objtemp->obj = objGot;
						Parameters[numParams].pdispVal = objtemp->GetIDispatch(TRUE);
					}
					
				}
				
			}
            return printAny(req->return_value());							  
		}
	}
	catch(const CORBA::Exception& excep) 
	{
		AfxMessageBox("Error while invoking request" );
		exit(6);
	}
	return vaResult;
}


VARIANT CObj::printAny(const CORBA::Any& info) 
{
    try 
    {
	   	CORBA::DynAny_var dynany = orb->create_dyn_any(info);
          	return display(dynany);
    }
    catch (CORBA::UserException& user) 
    {
        cerr << "User exception: " << user << endl;
    }
}

VARIANT CObj::display(CORBA::DynAny* value) 
{
	CORBA::TypeCode_var tc = value->type();
	switch (tc->kind()) 
	{
	    case CORBA::tk_null :
	    case CORBA::tk_void :
	    {

            VARIANT vaResult;
            VariantInit(&vaResult);
	        vaResult.vt = VT_EMPTY;
			return vaResult;
        }                          		
	    break;
	    case CORBA::tk_short :
	    {
            VARIANT vaResult;
            VariantInit(&vaResult);
	        vaResult.vt = VT_I2;
			vaResult.iVal =value->get_short();
			return vaResult;
        }
		break;
	    case CORBA::tk_ushort :
        {

	        VARIANT vaResult;
            VariantInit(&vaResult);
	
            vaResult.vt = VT_I2;
			vaResult.iVal =value->get_ushort();
			return vaResult;
        }
		break;
	    case CORBA::tk_long :
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
	
            vaResult.vt = VT_I4;
			vaResult.lVal =value->get_long();
			return vaResult;
        }
		break;
	    case CORBA::tk_ulong :
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_I4;
			vaResult.lVal =value->get_ulong();
			return vaResult;

        }
		break;
	    case CORBA::tk_float :
		{
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_I4;
			vaResult.fltVal =value->get_float();
			return vaResult;
        }
		break;
	    case CORBA::tk_double :
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_I8;
			vaResult.dblVal =value->get_double();
			return vaResult;
        }
		break;
	    case CORBA::tk_boolean :
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_BOOL;
			vaResult.boolVal =value->get_boolean();
			return vaResult;

        }
		break;
	    case CORBA::tk_char :
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_UI1;
			vaResult.bVal=value->get_char();
			return vaResult;

        }
		break;
	    case CORBA::tk_string : 
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_BSTR;
			CString csVal = value->get_string();
			vaResult.bstrVal = csVal.AllocSysString();
			return vaResult;
		}
   		break;
	    case CORBA::tk_objref : 
        {
       			// Get the return value;
    			VARIANT vaResult;
                VariantInit(&vaResult);
				CObj *pOBJ = new CObj(orb);
				pOBJ->obj =(CORBA::Object*)resultAny->value();
				pOBJ->intf = (pOBJ->obj)->_get_interface();
				vaResult.vt = VT_DISPATCH;
				vaResult.pdispVal = pOBJ->GetIDispatch(TRUE);
				return vaResult;
	    }
		break;
	    case CORBA::tk_longlong :
        {
    
            VARIANT vaResult;
            VariantInit(&vaResult);
    		vaResult.vt = VT_I4;
    		vaResult.lVal =value->get_ulong();
    		return vaResult;
        }               
		break;
	    case CORBA::tk_ulonglong :
        {
    
            VARIANT vaResult;
            VariantInit(&vaResult);
    		vaResult.vt = VT_I4;
    		vaResult.lVal =value->get_ulonglong();
    		return vaResult;
        }               
		break;
	    case CORBA::tk_wstring:
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_BSTR;
			CString csVal = value->get_wstring();
			vaResult.bstrVal = csVal.AllocSysString();
			return vaResult;
		}
		break;
	    case CORBA::tk_wchar:
        {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_UI1;
			vaResult.bVal=value->get_wchar();
			return vaResult;

        }
		break;
	    case CORBA::tk_struct :
	    case CORBA::tk_array :
	    case CORBA::tk_sequence : 
	    {
			VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_ARRAY| VT_VARIANT;
	        value->rewind(); 
			long temp = 0;
			while(value->next()) temp++;
			value->rewind(); 
			SAFEARRAY *psa;
			SAFEARRAYBOUND bounds = {temp+1,0};
			long ix ;
			long arrIndex = 0;
			psa = SafeArrayCreate(VT_VARIANT ,1,&bounds);
			do 
			{
		        CORBA::DynAny_var member = value->current_component();
				VARIANT vaResTemp ;
				VARIANT vaRes ;
				VariantInit(&vaRes);
				VariantInit(&vaResTemp);
				vaResTemp = display(member);
				V_VT(&vaRes) = vaResTemp.vt;
				vaRes = vaResTemp ;
				ix = arrIndex++;
//				CString csVal = vaRes.bstrVal;
//				csVal = vaResTemp.bstrVal;
//				csVal = display(member).bstrVal;
				SafeArrayPutElement(psa, &ix, &vaRes);
		    } while (value->next());
			vaResult.parray = psa;
/*
			VARIANT HUGEP *pbstr;
			HRESULT hr;

			// Get a pointer to the elements of the array.
			hr = SafeArrayAccessData(psa, (void HUGEP* FAR*)&pbstr);

			for (long i = 0; i < temp+1; i++)
			{
				CString csVal = pbstr[i].bstrVal;
				AfxMessageBox(csVal);
			}

			SafeArrayUnaccessData(psa);
*/			/*
			//Testing The SafeArray Here itself
			SAFEARRAY* psa1 = vaResult.parray;
			long UBound;
			VARIANT FAR *rgvar = new VARIANT[temp+1];
			
		
			for(int i = 0; i < UBound; ++i)
			{
				VariantInit(&rgvar[i]);
				ix = i;
				hresult = SafeArrayGetElement(psa, &ix, &rgvar[i]);
				CString csVal = rgvar[i].bstrVal;
			}*/
			return vaResult;
		}
		break;
	    default :
        {

	        VARIANT vaResult;
            VariantInit(&vaResult);
			vaResult.vt = VT_BSTR;
			CString csVal = value->get_wstring();
			vaResult.bstrVal = csVal.AllocSysString();
			return vaResult;
	    }
	}	
	VARIANT vaResult;
	VariantInit(&vaResult);
	return vaResult;
}


